function setInteraction(){
    mapsel.changed(mapSelectEvent);
    
    ////map color solution
    buttonmapcolor = createButton('change heatmap colors');
    buttonmapcolor.style('background-color',color(255,255,255,200));
    buttonmapcolor.style('color',color(0,0,15));
    buttonmapcolor.style('font-size','60%');
    buttonmapcolor.position(2*cellsize,mapmax-cellsize/2);
    buttonmapcolor.mousePressed(selectMapColor);
    
    //Interactivity0: show landscape or not
    checklandscape = createCheckbox('Navigation Heatmap',false);
    checklandscape.position(cellsize,mapmax-5*cellsize/2);
    checklandscape.style('color',color(200,255,255,200));
    checklandscape.changed(drawland);
    
    //Interactivity1: autorotation or not
    checkrotate = createCheckbox('Autorotation',true);
    checkrotate.position(cellsize,mapmax-11*cellsize/2);
    checkrotate.style('color',color(255,255,200,200));
    checkrotate.changed(drawrotate);
    
    //Interactivity2: show icon or not
    checkicon = createCheckbox('Landmark Icon',true);
    checkicon.position(cellsize,mapmax-9*cellsize/2);
    checkicon.style('color',color(255,255,200,200));
    checkicon.changed(drawiconjudge);
    
    //Interactivity3: show trajectories or not
    checktrajec = createCheckbox('Sample Trajectories',true);
    checktrajec.position(cellsize,mapmax-7*cellsize/2);
    checktrajec.style('color',color(255,255,200,200));
    checktrajec.changed(drawtrajec);
    
    
    //Interactivity4: show pointing error or not
    checkpointing = createCheckbox('Pointing Error',false);
    checkpointing.position(cellsize,mapmax+cellsize/2);
    checkpointing.style('color',color(255,200,255,200));
    checkpointing.changed(drawpointingerror);
    
    //Interactivity5: transparency of the pointing error
    pointingslider = createSlider(20,255,50);
    pointingslider.position(cellsize,mapmax+3*cellsize/2);
    sliderlabel1 = createP('Alpha');
    sliderlabel1.position(pointingslider.x * 1.5 + pointingslider.width, pointingslider.y-0.4*cellsize);
    sliderlabel1.style('color',color(255,255,255,200));
    sliderlabel1.style('font-size','80%');
    
    //Interactivity6: range of the pointing error shown on the canvas
    errorslider = createSlider(0,180,180);
    errorslider.position(cellsize,mapmax+5*cellsize/2);
    sliderlabel2 = createP('Range');
    sliderlabel2.position(errorslider.x * 1.5 + errorslider.width, errorslider.y-0.4*cellsize);
    sliderlabel2.style('color',color(255,255,255,200));
    sliderlabel2.style('font-size','80%');
    
    
    //Interactivity7: select trials
    triallabel3 = createP('Trial List');
    triallabel3.position(cellsize, mapmax+3*cellsize);
    triallabel3.style('color',color(255,200,255,200));
    for(var i = 0; i<trialRows;i++){
        booltriallist[i]=false;
        var j=i+1;
        checktriallist[i] = createCheckbox(trialmatrix[i][0]+' to '+trialmatrix[i][1],false);
        checktriallist[i].position(cellsize,mapmax+4.5*cellsize+i*cellsize/2);
        checktriallist[i].style('color',color(255,200,255,200));
    }
    ///select/clear all trials button
    buttontrial = createButton('Select/Clear All trials');
    buttontrial.style('background-color',color(255,200,255,200));
    buttontrial.style('color',color(0,0,15));
    buttontrial.position(cellsize,mapmax+15*cellsize);
    buttontrial.mousePressed(selectalltrial);
    
}

function drawpointingerror(){
    if(boolpointing){
        boolpointing=false;
    }else{boolpointing=true;}
}

function drawland(){
    if(boolland){
        boolland=false;
    }else{boolland=true;}
}

function drawiconjudge(){
    if(boolicon){
        boolicon=false;
    }else{boolicon=true;}
}
function drawtrajec(){
    if(booltrajec){
        booltrajec=false;
    }else{booltrajec=true;}
}
function drawrotate(){
    if(boolrotate){
        boolrotate=false;
    }else{boolrotate=true;}
}
function selecttrial(){
    for(var i = 0; i<trialRows;i++){
        if(checktriallist[i].checked()){
            booltriallist[i]=true;
        }else{booltriallist[i]=false;}
        //print(booltriallist[i]);
    }
}
function selectalltrial(){
    var selectedtrial = 0;
    for(var i = 0; i<trialRows;i++){
        if(booltriallist[i]){
            selectedtrial++;
        }
    }
    if(selectedtrial<5){
        for(i=0;i<trialRows;i++){
            checktriallist[i].removeAttribute('checked');
            checktriallist[i].attribute("checked",true);
            booltriallist[i]=true;
        }
    }else{
        for(i=0;i<trialRows;i++){
            checktriallist[i].removeAttribute('checked');
            booltriallist[i]=false;
            
        }
    }
}
function mapSelectEvent(){
    if(mapsel.value()=='female'){
        maptable=Femaletable;
        readlandscape();
    }else if(mapsel.value()=='male'){
        maptable=Maletable;
        readlandscape();
    }else{
        maptable=totaltable;
        readlandscape();
    }
}
function selectMapColor(){
    if(colorcurrent==colorpool[0]){
        colorcurrent=colorpool[1];
    }else if(colorcurrent==colorpool[1]){
        colorcurrent=colorpool[2];
    }else{colorcurrent=colorpool[0];}
    
}